program main
  use constantes
  use subrotinas
  implicit none
  integer :: i, j, k, m, n_caos, l
  real(8) :: x, y
  real(8) :: x0, y_sum(n), y_sum_temp(n), y_avg(n), y_avg2, y_avg3
  real(8) :: a, b
  real(8), dimension(2,2) :: ortogonal, triangular
  real(8) :: soma1, soma2, elyap1, elyap2, beta
    
  open(2, file='fig10a.dat', status='unknown')
  
!$omp parallel do & 
!$omp default(firstprivate) 
  do j = 1, grid
    a = amin + (amax - amin) * dble(j - 1) / dble(grid - 1)
    do k = 1, grid 
      b = amin + (bmax - bmin) * dble(k - 1) / dble(grid - 1)
      y_sum = 0.d0 
      n_caos = nci
loop_ci:    do m = 1, nci
        x0 = xmin + (xmax - xmin) * dble(m - 1) / dble(nci - 1)
        y_sum_temp = 0.d0
      beta = 0.0d0

      ortogonal(1,1) = cos(beta)
      ortogonal(1,2) = -sin(beta)
      ortogonal(2,1) = sin(beta)
      ortogonal(2,2) = cos(beta)

      soma1 = 0.0d0;      soma2 = 0.0d0  
        
        x = x0
        y = 0.d0

        do i = 1, n
          call mapa(y, x, a, b)
          call lyap(ortogonal, triangular, x, y, a, b)    
          soma1 = soma1 + log(abs(triangular(1,1)))
          soma2 = soma2 + log(abs(triangular(2,2)))
          y_sum_temp(i) = y_sum_temp(i) + y        
        end do
        
        elyap1 = soma1/dble(n)
        elyap2 = soma2/dble(n)
        
        if (elyap1 > 0.001d0) then
          y_sum = y_sum + y_sum_temp
        else
          n_caos = n_caos - 1
        end if
        
      end do loop_ci
      
      !$omp critical
      y_avg2 = 0.d0
      if (n_caos > 0) then
        y_avg = y_sum / dble(n_caos)
        do l = 1, n
          y_avg2 = y_avg2 + y_avg(l)
          y_avg3 = y_avg2/dble(l)
        end do
      else
        y_avg3 = 0.d0
      end if
      !$omp end critical
      
      !$omp critical
      write(2,*)a,b,y_avg3
      !$omp end critical
      
  end do
    
  end do
  !$omp end parallel do

end program
