program main
  use constantes
  use subrotinas
  implicit none
  integer :: i, k, m, sign_y, x_value
  real(8) :: x, y, x_fp, y_fp, residue
  real(8) :: x0, y0
  real(8), dimension(2,2) :: dm
    
  open(1, file='fig4b.dat', status='unknown')
  open(2, file='stable-fps.dat', status='unknown')
  open(3, file='unstable-fps.dat', status='unknown')
  open(4, file='fig4c.dat', status='unknown')
  open(5, file='shearless.dat', status='unknown')
      
  !$omp parallel do default(firstprivate) schedule(dynamic)
    do k = 1, grid 
      y0 = ymin + (ymax - ymin) * dble(k - 1) / dble(grid - 1)
      x0 = 0.5d0
      
      x = x0;      y = y0

      do i = 1, n

        call mapa(y, x)

        if (abs(y) < 5d0) then
           write(1,*)x,y
        end if

      end do

  end do
  !$omp end parallel do

! Check fixed points stability
do m = 0, 15
    do sign_y = -1, 1, 2
        do x_value = 0, 1
            x_fp = dble(x_value) * 0.5d0
            y_fp = sign_y * sqrt(1.d0 + dble(m)/a)
            call jacobian_matrix(dm, x_fp, y_fp)
            residue = (2.d0 - (dm(1,1) + dm(2,2)))/4.d0
            if (residue > 0.d0 .and. residue < 1.d0) then
                write(2,*) x_fp, y_fp
            else
                write(3,*) x_fp, y_fp
            end if
        end do
    end do
end do

    !$omp parallel do default(firstprivate) schedule(dynamic)  
    do k = 1, grid*100 
      y0 = -0.2d0 + (0.2d0 - (-0.2d0)) * float(k - 1) / float(grid*100 - 1)
      
      x0 = 0.5d0
      
      x = x0
      y = y0

      do i = 1, 10000
        call mapa_unbound(y, x)
      end do

     write(4,*)y0, (x-x0)/dble(10000)
  end do
  !$omp end parallel do  

  x = 0.5d0
  y = -0.10955095509550955d0 
  
      do i = 1, 10000
        call mapa(y, x)
        write(5,*)x,y
      end do
  
end program
