program nontwiststdmp
use constantes
use subrotinas
implicit none
integer :: i, j, jj
real(8) :: x, y, x0, y0, m, m_for, m_back
real(8) :: x_0, y_0, x_1, y_1, delta_x, delta_y
real(8), allocatable, dimension(:,:) :: m_norm

open(1,file='LD-raw-data',status='unknown')

allocate (m_norm(grid,grid))

m_norm = 0.d0

do j = 1, grid
  x0 = xmin + (xmax-xmin)*(dble(j)-1.d0)/(dble(grid)-1.d0)
!$omp parallel do default(firstprivate) schedule(dynamic) shared(m_norm,m_f,m_b)  
  do jj = 1, grid
    y0 = ymin + (ymax-ymin)*(dble(jj)-1.d0)/(dble(grid)-1.d0)
    
    x = x0; y = y0
    m = 0.d0; 

    ! iteradas pra frente
    do i = 1, n_f
      x_0 = x; y_0 = y
      call mapa (y, x)
      x_1 = x; y_1 = y
      call distancia (y_1, x_1, y_0, x_0, delta_x, delta_y)
      m_for = m_for + (delta_x**2.d0 + delta_y**2.d0 )**(1.d0/2.d0)      
    end do

    x = x0; y = y0

    !iteradas pra tras
    do i = 1, n_b
      x_0 = x; y_0 = y
      call mapa_inv (y, x)
      x_1 = x; y_1 = y
      call distancia (y_1, x_1, y_0, x_0, delta_x, delta_y)
      m_back = m_back + (delta_x**2.d0 + delta_y**2.d0 )**(1.d0/2.d0)
    end do
    
! escreve array dos lds
    m = m_for + m_back
!$omp critical
    m_norm(j,jj) = m
!$omp end critical

    end do
!$omp end parallel do     
end do

! saida arrays dos LDs
do i = 1, grid
  do j = 1, grid
    write(1,*)m_norm(i,j)  
  end do
end do

end program
