program nontwiststdmp
use constantes
use subrotinas
implicit none
integer :: i, j
real(8) :: x0, y0
real(8), allocatable, dimension(:,:) :: m_norm
real(8), allocatable, dimension(:,:) :: laplacian_smooth

open(1, file='LD-raw-data',status='old',action='read')
open(41,file='LD.dat',status='unknown')
open(71, file='lapLD.dat', status='unknown')

allocate (m_norm(grid,grid))
allocate (laplacian_smooth(grid,grid))

m_norm = 0.d0 
laplacian_smooth = 0.d0

do i = 1, grid
  do j = 1, grid
    read(1, *) m_norm(i, j) 
  end do
end do

! aplica filtro laplaciano
call laplacian_filter(m_norm, laplacian_smooth, grid, grid)

! escreve arquivos de saida
do i = 1, grid
  x0 = xmin + (xmax-xmin)*(dble(i)-1.d0)/(dble(grid)-1.d0)
  do j = 1, grid
    y0 = ymin + (ymax-ymin)*(dble(j)-1.d0)/(dble(grid)-1.d0)
    write(41,*)x0,y0,m_norm(i,j) 
  end do
end do

do i = 1, grid
  x0 = xmin + (xmax-xmin)*(dble(i)-1.d0)/(dble(grid)-1.d0)
  do j = 1, grid
    y0 = ymin + (ymax-ymin)*(dble(j)-1.d0)/(dble(grid)-1.d0)
    write(71,*)x0,y0,log10(abs(laplacian_smooth(i,j)))
  end do
end do

end program
