program main
  use constantes
  use subrotinas
  implicit none
  integer :: i, j, n_caos
  real(8) :: x, y, x0, y0
  real(8) :: y_sum(n), y_avg(n), y_avg2, y_avg3(n), y_sum_sq(n), y_std(n)
  real(8) :: y_sum3_sq, y_avg3_std(n), y_sum_temp(n), y_sum_sq_temp(n)
  real(8) :: hist10(grid)
  real(8), dimension(2,2) :: ortogonal, triangular, dm
  real(8) :: soma1, soma2, elyap1, elyap2, beta
    
  open(2, file='fig9b-blue.dat', status='unknown')
    
  y_sum = 0.d0
  y_sum_sq = 0.d0
  y_sum3_sq = 0.d0
  n_caos = grid  
  
  !$omp parallel do default(firstprivate) schedule(dynamic) shared(y_sum,y_sum_sq,y_sum_temp,y_sum_sq_temp,n_caos)
  do j = 1, grid

  y_sum_temp = 0.d0  
  y_sum_sq_temp = 0.d0

      x0 = xmin + (xmax - xmin) * dble(j - 1) / dble(grid - 1)
      y0 = 0.d0
      
      x = x0
      y = y0

      beta = 0.0d0
      ortogonal(1,1) = cos(beta)
      ortogonal(1,2) = -sin(beta)
      ortogonal(2,1) = sin(beta)
      ortogonal(2,2) = cos(beta)

      soma1 = 0.0d0;      soma2 = 0.0d0  

      do i = 1, n
        call mapa(y, x)
        call lyap(ortogonal, triangular, x, y)    
        soma1 = soma1 + log(abs(triangular(1,1)))
        soma2 = soma2 + log(abs(triangular(2,2)))
        !$omp critical        
        y_sum_temp(i) = y_sum_temp(i) + y
        y_sum_sq_temp(i) = y_sum_sq_temp(i) + y * y  
        !$omp end critical                               
      end do
      
      elyap1 = soma1/dble(n)
      elyap2 = soma2/dble(n)
      
      !$omp critical  
        if (elyap1 > 0.001d0) then
          y_sum = y_sum + y_sum_temp
          y_sum_sq = y_sum_sq + y_sum_sq_temp
        else
          n_caos = n_caos - 1
        end if   
      !$omp end critical
  end do
  !$omp end parallel do
    
 y_avg = y_sum / n_caos  
 y_std = sqrt((y_sum_sq / n_caos) - y_avg**2)

  y_avg2 = 0.d0
  do i = 1, n
    y_avg2 = y_avg2 + y_avg(i)
    y_avg3(i) = y_avg2 / dble(i)
    y_sum3_sq = y_sum3_sq + y_avg(i) * y_avg(i)
    if (i > 1) then
      y_avg3_std(i) = sqrt((y_sum3_sq / dble(i)) - (y_avg3(i)**2))
    else
      y_avg3_std(i) = 0.d0
    end if
    write(2,*) i, y_avg3(i), y_avg3_std(i)
  end do
  
end program
